## xeus-python 0.8.6

=== CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Martin Renou, Johan Mabille, Sylvain Corlay, and     #
# Wolf Vollprecht                                                          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.4.3)
project(xeus-python)

set(XEUS_PYTHON_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

# Versionning
# ===========

file(STRINGS "${XEUS_PYTHON_INCLUDE_DIR}/xeus-python/xeus_python_config.hpp" xpyt_version_defines
     REGEX "#define XPYT_VERSION_(MAJOR|MINOR|PATCH)")
foreach (ver ${xpyt_version_defines})
    if (ver MATCHES "#define XPYT_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XPYT_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif ()
endforeach ()
set(${PROJECT_NAME}_VERSION
    ${XPYT_VERSION_MAJOR}.${XPYT_VERSION_MINOR}.${XPYT_VERSION_PATCH})
message(STATUS "Building xeus-python v${${PROJECT_NAME}_VERSION}")

# Configuration
# =============

include(GNUInstallDirs)

if (NOT DEFINED XPYTHON_KERNELSPEC_PATH)
    set(XPYTHON_KERNELSPEC_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/")
endif ()

# Running find_package(PythonInterp) to retrieve the Python version
# which is not exported by Pybind11's cmake.
# Cf. https://github.com/pybind/pybind11/issues/2268
find_package(PythonInterp ${PythonLibsNew_FIND_VERSION} REQUIRED)

configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
)

# Build options
# =============

# Compilation options
OPTION(XPYT_DISABLE_ARCH_NATIVE "disable -march=native flag" OFF)
OPTION(XPYT_DISABLE_TUNE_GENERIC "disable -mtune=generic flag" OFF)
OPTION(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)

option(XPYT_BUILD_STATIC "Build xeus-python static library" ON)
OPTION(XPYT_BUILD_SHARED "Split xpython build into executable and library" ON)
OPTION(XPYT_BUILD_XPYTHON_EXECUTABLE "Build the xpython executable" ON)
OPTION(XPYT_BUILD_XPYTHON_EXTENSION "Build the xpython extension module" OFF)

OPTION(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
OPTION(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)

# Test options
OPTION(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
OPTION(XPYT_DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)

# Dependencies
# ============

set(xeus_REQUIRED_VERSION 0.24.0)
set(pybind11_REQUIRED_VERSION 2.2.4)
set(pybind11_json_REQUIRED_VERSION 0.2.2)

if (NOT TARGET xeus AND NOT TARGET xeus-static)
    find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
endif ()
if (NOT TARGET pybind11)
    find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
endif ()
if (NOT TARGET pybind11_json)
    find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
endif ()

# Flags
# =====

include(CheckCXXCompilerFlag)

set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251 /wd4141")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4018 /wd4267 /wd4715 /wd4146 /wd4129")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-parameter -Wextra -Wreorder")
    if (XPYT_DISABLE_ARCH_NATIVE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mtune=generic")
    elseif (XPYT_DISABLE_TUNE_GENERIC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else ()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
    endif ()

    CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)

    if (HAS_CPP14_FLAG)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    else ()
        message(FATAL_ERROR "Unsupported compiler -- xeus requires C++14 support!")
    endif ()
endif ()

# Source files
# ============

set(XEUS_PYTHON_SRC
    src/xcomm.cpp
    src/xcomm.hpp
    src/xdebugger.cpp
    src/xdisplay.cpp
    src/xdisplay.hpp
    src/xinput.cpp
    src/xinput.hpp
    src/xinspect.cpp
    src/xinspect.hpp
    src/xinteractiveshell.cpp
    src/xinteractiveshell.hpp
    src/xinterpreter.cpp
    src/xis_complete.cpp
    src/xis_complete.hpp
    src/xlinecache.cpp
    src/xlinecache.hpp
    src/xnullcontext.cpp
    src/xnullcontext.hpp
    src/xptvsd_client.cpp
    src/xptvsd_client.hpp
    src/xstream.cpp
    src/xstream.hpp
    src/xtraceback.cpp
    src/xtraceback.hpp
    src/xutils.cpp
    src/xutils.hpp
)

set(XEUS_PYTHON_HEADERS
    include/xeus-python/xdebugger.hpp
    include/xeus-python/xeus_python_config.hpp
    include/xeus-python/xinterpreter.hpp
)

set(XPYTHON_SRC
    src/main.cpp
    src/xpaths.hpp
    src/xpaths.cpp
    src/xpythonhome.hpp
    src/xpythonhome.cpp
)

set(XPYTHON_EXTENSION_SRC
    src/xpython_extension.cpp
)

# Targets and link - Macros
# =========================

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib; ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

macro(xpyt_set_common_options target_name)
    if (MSVC)
        target_compile_options(${target_name} PUBLIC /wd4251 /wd4141)
        target_compile_options(${target_name} PUBLIC /wd4018 /wd4267 /wd4715 /wd4146 /wd4129)
    endif ()

    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
        CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
        CMAKE_CXX_COMPILER_ID MATCHES "Intel")

        target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)
    
        # Mtune generic/native
        if (XPYT_DISABLE_ARCH_NATIVE AND NOT XPYT_DISABLE_TUNE_GENERIC)
            target_compile_options(${target_name} PUBLIC -mtune=generic)
        elseif (XPYT_DISABLE_TUNE_GENERIC)
        else ()
            target_compile_options(${target_name} PUBLIC -march=native)
        endif ()

        # C++14 flag
        CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)
        if (HAS_CPP14_FLAG)
            target_compile_features(${target_name} PRIVATE cxx_std_14)
        else ()
            message(FATAL_ERROR "Unsupported compiler -- xeus-python requires C++14 support!")
        endif ()

        # Enable link time optimization and set the default symbol
        # visibility to hidden (very important to obtain small binaries)
        if (NOT ${U_CMAKE_BUILD_TYPE} MATCHES DEBUG)
            # Check for Link Time Optimization support
            # (GCC/Clang)
            CHECK_CXX_COMPILER_FLAG("-flto" HAS_LTO_FLAG)
            if (HAS_LTO_FLAG)
                target_compile_options(${target_name} PUBLIC -flto)
            endif ()

            # Avoids removing symbols from the static library
            CHECK_CXX_COMPILER_FLAG("-ffat-lto-objects" HAS_FATLTO_FLAG)
            if (${linkage_upper} MATCHES "STATIC" AND  HAS_FATLTO_FLAG)
                message(STATUS "ENABLE FAT LTO OBJECTS")
                target_compile_options(${target_name} PUBLIC -ffat-lto-objects)
            endif ()

            # Intel equivalent to LTO is called IPO
            if (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
                CHECK_CXX_COMPILER_FLAG("-ipo" HAS_IPO_FLAG)
                if (HAS_IPO_FLAG)
                    target_compile_options(${target_name} PUBLIC -ipo)
                endif ()
            endif ()
        endif ()

    endif ()

    if (APPLE)
        set_target_properties(${target_name} PROPERTIES
            MACOSX_RPATH ON
        )
    else ()
        set_target_properties(${target_name} PROPERTIES
            BUILD_WITH_INSTALL_RPATH 1
            SKIP_BUILD_RPATH FALSE
        )
    endif ()

    set_target_properties(${target_name} PROPERTIES
        INSTALL_RPATH_USE_LINK_PATH TRUE
    )
endmacro()

# Common macro kernels (xpython and xpython_extension)
macro(xpyt_set_kernel_options target_name)
    if(XPYT_ENABLE_PYPI_WARNING)
        message(STATUS "Enabling PyPI warning for target: " ${target_name})
        target_compile_definitions(${target_name} PRIVATE XEUS_PYTHON_PYPI_WARNING)
    endif()

    if (XPYT_USE_SHARED_XEUS_PYTHON)
        target_link_libraries(${target_name} PRIVATE xeus-python)

        if(CMAKE_DL_LIBS)
            target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS} util)
        endif()
    else ()
        target_link_libraries(${target_name} PRIVATE xeus-python-static)
    endif()

    find_package(Threads) # TODO: add Threads as a dependence of xeus or xeus-static?
    target_link_libraries(${target_name} PRIVATE ${CMAKE_THREAD_LIBS_INIT})
endmacro()

# Common macro for shared and static library xeus-python
macro(xpyt_create_target target_name linkage output_name)
    string(TOUPPER "${linkage}" linkage_upper)

    if (NOT ${linkage_upper} MATCHES "^(SHARED|STATIC)$")
        message(FATAL_ERROR "Invalid library linkage: ${linkage}")
    endif ()

    add_library(${target_name} ${linkage_upper} ${XEUS_PYTHON_SRC} ${XEUS_PYTHON_HEADERS})
    xpyt_set_common_options(${target_name})

    set_target_properties(${target_name} PROPERTIES
                          PUBLIC_HEADER "${XEUS_PYTHON_HEADERS}"
                          PREFIX ""
                          VERSION ${${PROJECT_NAME}_VERSION}
                          SOVERSION ${XPYT_VERSION_MAJOR}
                          OUTPUT_NAME "lib${output_name}")

    target_compile_definitions(${target_name} PUBLIC "XEUS_PYTHON_EXPORTS")

    target_include_directories(${target_name}
                               PUBLIC
                               ${PYTHON_INCLUDE_DIRS}
                               $<BUILD_INTERFACE:${XEUS_PYTHON_INCLUDE_DIR}>
                               $<INSTALL_INTERFACE:include>)

    if (XPYT_USE_SHARED_XEUS)
        set(XPYT_XEUS_TARGET xeus)
    else ()
        set(XPYT_XEUS_TARGET xeus-static)
    endif ()

    target_link_libraries(${target_name} PUBLIC ${XPYT_XEUS_TARGET} PRIVATE pybind11::pybind11 pybind11_json)
    if (WIN32 OR CYGWIN)
        target_link_libraries(${target_name} PRIVATE ${PYTHON_LIBRARIES})
    elseif (APPLE)
        target_link_libraries(${target_name} PRIVATE "-undefined dynamic_lookup")
    endif ()

    find_package(Threads) # TODO: add Threads as a dependence of xeus-static?
    target_link_libraries(${target_name} PRIVATE ${CMAKE_THREAD_LIBS_INIT})
endmacro()

# xeus-python
# ===========

set(XEUS_PYTHON_TARGETS "")

if (XPYT_BUILD_SHARED)
    # Build libraries
    xpyt_create_target(xeus-python SHARED xeus-python)
    list(APPEND XEUS_PYTHON_TARGETS xeus-python)
endif ()

if (XPYT_BUILD_STATIC)
    # On Windows, a static library should use a different output name
    # to avoid the conflict with the import library of a shared one.
    if (CMAKE_HOST_WIN32)
        xpyt_create_target(xeus-python-static STATIC xeus-python-static)
    else ()
        xpyt_create_target(xeus-python-static STATIC xeus-python)
    endif ()
    list(APPEND XEUS_PYTHON_TARGETS xeus-python-static)
endif ()

# xpython
# =======

if (XPYT_BUILD_XPYTHON_EXECUTABLE)
    add_executable(xpython ${XPYTHON_SRC})
    target_link_libraries(xpython PRIVATE pybind11::embed)

    xpyt_set_common_options(xpython)
    xpyt_set_kernel_options(xpython)

    if (XEUS_PYTHONHOME_RELPATH)
        target_compile_definitions(xpython PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
    endif()
endif()

# xpython_extension
# =================

=== debian/changelog ===
xeus-python (0.8.6-2) unstable; urgency=medium

  * Patch CMakeLists to actually respect XPYT_DISABLE_MTUNE_GENERIC, which was
    causing build failures on most non-x86 architectures

 -- Gordon Ball <gordon@chronitis.net>  Fri, 30 Oct 2020 09:11:31 +0000

xeus-python (0.8.6-1) unstable; urgency=medium

  * Initial release. (Closes: #973043)

 -- Gordon Ball <gordon@chronitis.net>  Wed, 28 Oct 2020 16:17:17 +0000

=== debian/control ===
Source: xeus-python
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkg-config,
               xeus-dev,
               pybind11-dev,
               pybind11-json-dev,
               python3-dev,
Standards-Version: 4.5.0
Section: science
Homepage: https://github.com/jupyter-xeus/xeus-python
Vcs-Git: https://salsa.debian.org/science-team/xeus-python.git
Vcs-Browser: https://salsa.debian.org/science-team/xeus-python
Rules-Requires-Root: no

Package: xeus-python-dev
Architecture: any
Depends: ${misc:Depends},
         libxeus-python0 (= ${binary:Version}),
         xeus-dev,
         pybind11-dev,
         pybind11-json-dev,
         python3-dev,
Description: Native jupyter kernel for python (headers)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the development headers.

Package: libxeus-python0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: Native jupyter kernel for python (library)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the library.

Package: xpython
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3-jedi,
         python3-pygments,
Recommends: python3-ipython
Description: Native jupyter kernel for python (binary)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the xpython executable and jupyter kernel configuration.

## xeus-python 0.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -69,7 +69,7 @@
 # Dependencies
 # ============
 
-set(xeus_REQUIRED_VERSION 0.24.0)
+set(xeus_REQUIRED_VERSION 0.25.0)
 set(pybind11_REQUIRED_VERSION 2.2.4)
 set(pybind11_json_REQUIRED_VERSION 0.2.2)
 
@@ -97,7 +97,7 @@
 
 if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-parameter -Wextra -Wreorder")
-    if (XPYT_DISABLE_ARCH_NATIVE)
+    if (XPYT_DISABLE_ARCH_NATIVE AND NOT XPYT_DISABLE_TUNE_GENERIC)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mtune=generic")
     elseif (XPYT_DISABLE_TUNE_GENERIC)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
@@ -118,9 +118,9 @@
 # ============
 
 set(XEUS_PYTHON_SRC
-    src/xcomm.cpp
-    src/xcomm.hpp
     src/xdebugger.cpp
+    src/xdebugpy_client.hpp
+    src/xdebugpy_client.cpp
     src/xdisplay.cpp
     src/xdisplay.hpp
     src/xinput.cpp
@@ -136,8 +136,8 @@
     src/xlinecache.hpp
     src/xnullcontext.cpp
     src/xnullcontext.hpp
-    src/xptvsd_client.cpp
-    src/xptvsd_client.hpp
+    src/xpython_kernel.cpp
+    src/xpython_kernel.hpp
     src/xstream.cpp
     src/xstream.hpp
     src/xtraceback.cpp
@@ -184,7 +184,7 @@
         CMAKE_CXX_COMPILER_ID MATCHES "Intel")
 
         target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)
-    
+
         # Mtune generic/native
         if (XPYT_DISABLE_ARCH_NATIVE AND NOT XPYT_DISABLE_TUNE_GENERIC)
             target_compile_options(${target_name} PUBLIC -mtune=generic)
@@ -344,8 +344,4 @@
     if (XEUS_PYTHONHOME_RELPATH)
         target_compile_definitions(xpython PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
     endif()
-endif()
-
-# xpython_extension
-# =================
-
+

=== debian/changelog ===
xeus-python (0.9.0-1) unstable; urgency=medium

  * New upstream version 0.9.0
  * Drop XPYT_DISABLE_TUNE_GENERIC patch, applied upstream
  * Add explicit build-dependencies on nlohmann-json-dev, libzmq3-dev, xtl-dev
    rather than relying on transitive dependencies

 -- Gordon Ball <gordon@chronitis.net>  Fri, 20 Nov 2020 20:59:55 +0000

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,12 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                pkg-config,
-               xeus-dev,
-               pybind11-dev,
-               pybind11-json-dev,
+               libzmq3-dev,
+               xeus-dev (>= 0.25~),
+               xtl-dev (>= 0.6.8~),
+               nlohmann-json3-dev (>= 3.6.1~),
+               pybind11-dev (>= 2.2.4~),
+               pybind11-json-dev (>= 0.2.6~),
                python3-dev,
 Standards-Version: 4.5.0
 Section: science

## xeus-python 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -129,6 +129,8 @@
     src/xinspect.hpp
     src/xinteractiveshell.cpp
     src/xinteractiveshell.hpp
+    src/xinternal_utils.cpp
+    src/xinternal_utils.hpp
     src/xinterpreter.cpp
     src/xis_complete.cpp
     src/xis_complete.hpp
@@ -141,15 +143,15 @@
     src/xstream.cpp
     src/xstream.hpp
     src/xtraceback.cpp
-    src/xtraceback.hpp
     src/xutils.cpp
-    src/xutils.hpp
 )
 
 set(XEUS_PYTHON_HEADERS
     include/xeus-python/xdebugger.hpp
     include/xeus-python/xeus_python_config.hpp
     include/xeus-python/xinterpreter.hpp
+    include/xeus-python/xtraceback.hpp
+    include/xeus-python/xutils.hpp
 )
 
 set(XPYTHON_SRC
@@ -200,33 +202,6 @@
         else ()
             message(FATAL_ERROR "Unsupported compiler -- xeus-python requires C++14 support!")
         endif ()
-
-        # Enable link time optimization and set the default symbol
-        # visibility to hidden (very important to obtain small binaries)
-        if (NOT ${U_CMAKE_BUILD_TYPE} MATCHES DEBUG)
-            # Check for Link Time Optimization support
-            # (GCC/Clang)
-            CHECK_CXX_COMPILER_FLAG("-flto" HAS_LTO_FLAG)
-            if (HAS_LTO_FLAG)
-                target_compile_options(${target_name} PUBLIC -flto)
-            endif ()
-
-            # Avoids removing symbols from the static library
-            CHECK_CXX_COMPILER_FLAG("-ffat-lto-objects" HAS_FATLTO_FLAG)
-            if (${linkage_upper} MATCHES "STATIC" AND  HAS_FATLTO_FLAG)
-                message(STATUS "ENABLE FAT LTO OBJECTS")
-                target_compile_options(${target_name} PUBLIC -ffat-lto-objects)
-            endif ()
-
-            # Intel equivalent to LTO is called IPO
-            if (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-                CHECK_CXX_COMPILER_FLAG("-ipo" HAS_IPO_FLAG)
-                if (HAS_IPO_FLAG)
-                    target_compile_options(${target_name} PUBLIC -ipo)
-                endif ()
-            endif ()
-        endif ()
-
     endif ()
 
     if (APPLE)
@@ -345,3 +320,41 @@
         target_compile_definitions(xpython PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
     endif()
 
+    target_compile_definitions(xpython PRIVATE XEUS_PYTHON_EXECUTABLE="${PYTHON_EXECUTABLE}")
+endif()
+
+# xpython_extension
+# =================
+
+if (XPYT_BUILD_XPYTHON_EXTENSION)
+    pybind11_add_module(xpython_extension ${XPYTHON_EXTENSION_SRC})
+
+    xpyt_set_common_options(xpython_extension)
+    xpyt_set_kernel_options(xpython_extension)
+endif()
+
+# Tests
+# =====
+
+if(XPYT_DOWNLOAD_GTEST OR XPYT_GTEST_SRC_DIR)
+    set(XPYT_BUILD_TESTS ON)
+endif()
+
+if(XPYT_BUILD_TESTS)
+    add_subdirectory(test)
+endif()
+
+# Installation
+# ============
+
+include(CMakePackageConfigHelpers)
+
+set(XEUS_PYTHON_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for xeus-pythonConfig.cmake")
+
+# Install xeus-python and xeus-python-static
+if (XPYT_BUILD_SHARED)
+    install(TARGETS ${XEUS_PYTHON_TARGETS}
+            EXPORT ${PROJECT_NAME}-targets
+            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}

=== debian/changelog ===
xeus-python (0.9.2-1) unstable; urgency=medium

  * New upstream version 0.9.2
  * Rebase patches, increment versioned dependency on xeus-dev

 -- Gordon Ball <gordon@chronitis.net>  Fri, 11 Dec 2020 13:00:27 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                cmake,
                pkg-config,
                libzmq3-dev,
-               xeus-dev (>= 0.25~),
+               xeus-dev (>= 0.25.3~),
                xtl-dev (>= 0.6.8~),
                nlohmann-json3-dev (>= 3.6.1~),
                pybind11-dev (>= 2.2.4~),

## xeus-python 0.9.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -69,10 +69,14 @@
 # Dependencies
 # ============
 
+set(xtl_REQUIRED_VERSION 0.6.23)
 set(xeus_REQUIRED_VERSION 0.25.0)
-set(pybind11_REQUIRED_VERSION 2.2.4)
+set(pybind11_REQUIRED_VERSION 2.6.0)
 set(pybind11_json_REQUIRED_VERSION 0.2.2)
 
+if (NOT TARGET xtl)
+    find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
+endif ()
 if (NOT TARGET xeus AND NOT TARGET xeus-static)
     find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
 endif ()
@@ -138,6 +142,7 @@
     src/xlinecache.hpp
     src/xnullcontext.cpp
     src/xnullcontext.hpp
+    src/xpaths.cpp
     src/xpython_kernel.cpp
     src/xpython_kernel.hpp
     src/xstream.cpp
@@ -149,6 +154,7 @@
 set(XEUS_PYTHON_HEADERS
     include/xeus-python/xdebugger.hpp
     include/xeus-python/xeus_python_config.hpp
+    include/xeus-python/xpaths.hpp
     include/xeus-python/xinterpreter.hpp
     include/xeus-python/xtraceback.hpp
     include/xeus-python/xutils.hpp
@@ -156,10 +162,6 @@
 
 set(XPYTHON_SRC
     src/main.cpp
-    src/xpaths.hpp
-    src/xpaths.cpp
-    src/xpythonhome.hpp
-    src/xpythonhome.cpp
 )
 
 set(XPYTHON_EXTENSION_SRC
@@ -273,7 +275,7 @@
         set(XPYT_XEUS_TARGET xeus-static)
     endif ()
 
-    target_link_libraries(${target_name} PUBLIC ${XPYT_XEUS_TARGET} PRIVATE pybind11::pybind11 pybind11_json)
+    target_link_libraries(${target_name} PUBLIC ${XPYT_XEUS_TARGET} xtl PRIVATE pybind11::pybind11 pybind11_json)
     if (WIN32 OR CYGWIN)
         target_link_libraries(${target_name} PRIVATE ${PYTHON_LIBRARIES})
     elseif (APPLE)
@@ -282,6 +284,10 @@
 
     find_package(Threads) # TODO: add Threads as a dependence of xeus-static?
     target_link_libraries(${target_name} PRIVATE ${CMAKE_THREAD_LIBS_INIT})
+
+    if (XEUS_PYTHONHOME_RELPATH)
+        target_compile_definitions(${target_name} PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
+    endif()
 endmacro()
 
 # xeus-python
@@ -315,12 +321,6 @@
 
     xpyt_set_common_options(xpython)
     xpyt_set_kernel_options(xpython)
-
-    if (XEUS_PYTHONHOME_RELPATH)
-        target_compile_definitions(xpython PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
-    endif()
-
-    target_compile_definitions(xpython PRIVATE XEUS_PYTHON_EXECUTABLE="${PYTHON_EXECUTABLE}")
 endif()
 
 # xpython_extension

=== test/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Martin Renou, Johan Mabille, Sylvain Corlay, and     #
# Wolf Vollprecht                                                          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

# Unit tests
# ==========

cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(xeus-python-test)

    enable_testing()

    find_package(xeus-python REQUIRED CONFIG)
endif ()

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if(CMAKE_CXX_COMPILER_ID MATCHES Clang OR CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)

    CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
    if (HAS_MARCH_NATIVE)
        add_compile_options(-march=native)
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES MSVC)
    add_compile_options(/EHsc /MP /bigobj)
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
endif()

if(XPYT_DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    if(XPYT_DOWNLOAD_GTEST)
        # Download and unpack googletest at configure time
        configure_file(downloadGTest.cmake.in googletest-download/CMakeLists.txt)
    else()
        # Copy local source of googletest at configure time
        configure_file(copyGTest.cmake.in googletest-download/CMakeLists.txt)
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
    if(result)
        message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
    if(result)
        message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()

    # Add googletest directly to our build. This defines
    # the gtest and gtest_main targets.
    add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                     ${CMAKE_CURRENT_BINARY_DIR}/googletest-build EXCLUDE_FROM_ALL)

    set(GTEST_INCLUDE_DIRS "${gtest_SOURCE_DIR}/include")
    set(GTEST_BOTH_LIBRARIES  gtest_main gtest)
else()
    find_package(GTest REQUIRED)
endif()

find_package(Threads)

include_directories(${GTEST_INCLUDE_DIRS} SYSTEM)

set(XEUS_PYTHON_TESTS
    ../src/xutils.cpp
    test_debugger.cpp
    xeus_client.hpp
    xeus_client.cpp
)

add_executable(test_xeus_python ${XEUS_PYTHON_TESTS})
if(XPYT_DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    add_dependencies(test_xeus_python gtest_main)
endif()

if (APPLE)
    set_target_properties(test_xeus_python PROPERTIES
        MACOSX_RPATH ON
    )
else()
    set_target_properties(test_xeus_python PROPERTIES
        BUILD_WITH_INSTALL_RPATH 1
        SKIP_BUILD_RPATH FALSE
    )
endif()

set_target_properties(test_xeus_python PROPERTIES
    INSTALL_RPATH_USE_LINK_PATH TRUE
)

include_directories(${PYTHON_INCLUDE_DIRS})
target_link_libraries(test_xeus_python ${PYTHON_LIBRARIES} xeus ${GTEST_BOTH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
target_compile_definitions(test_xeus_python PRIVATE XEUS_PYTHONHOME="${PYTHON_PREFIX}")
target_include_directories(test_xeus_python PRIVATE ${XEUS_PYTHON_INCLUDE_DIR})

add_custom_target(xtest COMMAND test_xeus_python DEPENDS test_xeus_python)

=== debian/changelog ===
xeus-python (0.9.5-1) unstable; urgency=medium

  * New upstream version 0.9.5
  * Depend upon xtl-dev 0.6.23

 -- Gordon Ball <gordon@chronitis.net>  Tue, 12 Jan 2021 19:05:47 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                pkg-config,
                libzmq3-dev,
                xeus-dev (>= 0.25.3~),
-               xtl-dev (>= 0.6.8~),
+               xtl-dev (>= 0.6.23~),
                nlohmann-json3-dev (>= 3.6.1~),
                pybind11-dev (>= 2.2.4~),
                pybind11-json-dev (>= 0.2.6~),

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DPYTHON_EXECUTABLE=/usr/bin/python3 -DXPYT_DISABLE_ARCH_NATIVE=1 -DXPYT_DISABLE_TUNE_GENERIC=1

=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus-python/tags .*/archive/([\d\.-]+)\.tar\.gz

## xeus-python 0.12.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -72,7 +72,7 @@
 set(xtl_REQUIRED_VERSION 0.6.23)
 set(xeus_REQUIRED_VERSION 0.25.0)
 set(pybind11_REQUIRED_VERSION 2.6.0)
-set(pybind11_json_REQUIRED_VERSION 0.2.2)
+set(pybind11_json_REQUIRED_VERSION 0.2.8)
 
 if (NOT TARGET xtl)
     find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
@@ -80,7 +80,7 @@
 if (NOT TARGET xeus AND NOT TARGET xeus-static)
     find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
 endif ()
-if (NOT TARGET pybind11)
+if (NOT TARGET pybind11::headers)
     find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
 endif ()
 if (NOT TARGET pybind11_json)
@@ -91,8 +91,6 @@
 # =====
 
 include(CheckCXXCompilerFlag)
-
-set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
 
 if (MSVC)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251 /wd4141")
@@ -122,6 +120,10 @@
 # ============
 
 set(XEUS_PYTHON_SRC
+    src/xcomm.cpp
+    src/xcomm.hpp
+    src/xcompiler.cpp
+    src/xcompiler.hpp
     src/xdebugger.cpp
     src/xdebugpy_client.hpp
     src/xdebugpy_client.cpp
@@ -129,22 +131,10 @@
     src/xdisplay.hpp
     src/xinput.cpp
     src/xinput.hpp
-    src/xinspect.cpp
-    src/xinspect.hpp
-    src/xinteractiveshell.cpp
-    src/xinteractiveshell.hpp
     src/xinternal_utils.cpp
     src/xinternal_utils.hpp
     src/xinterpreter.cpp
-    src/xis_complete.cpp
-    src/xis_complete.hpp
-    src/xlinecache.cpp
-    src/xlinecache.hpp
-    src/xnullcontext.cpp
-    src/xnullcontext.hpp
     src/xpaths.cpp
-    src/xpython_kernel.cpp
-    src/xpython_kernel.hpp
     src/xstream.cpp
     src/xstream.hpp
     src/xtraceback.cpp
@@ -358,3 +348,12 @@
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
             LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xeus-python)
+
+    # Makes the project importable from the build directory
+    export(EXPORT ${PROJECT_NAME}-targets
+           FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
+endif ()
+
+# Install xpython
+if (XPYT_BUILD_XPYTHON_EXECUTABLE)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -107,7 +107,6 @@
 
 include_directories(${PYTHON_INCLUDE_DIRS})
 target_link_libraries(test_xeus_python ${PYTHON_LIBRARIES} xeus ${GTEST_BOTH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
-target_compile_definitions(test_xeus_python PRIVATE XEUS_PYTHONHOME="${PYTHON_PREFIX}")
 target_include_directories(test_xeus_python PRIVATE ${XEUS_PYTHON_INCLUDE_DIR})
 
 add_custom_target(xtest COMMAND test_xeus_python DEPENDS test_xeus_python)

=== debian/changelog ===
xeus-python (0.12.5-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 14 Jan 2022 14:02:06 +0000

xeus-python (0.12.5-1) unstable; urgency=medium

  * d/watch: new github tarball URL
  * Rebase patches
  * d/control: bump xeus, xtl, pybind11-json dependencies
  * New upstream version 0.12.5

 -- Gordon Ball <gordon@chronitis.net>  Sat, 09 Oct 2021 21:40:01 +0000

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,11 @@
                cmake,
                pkg-config,
                libzmq3-dev,
-               xeus-dev (>= 0.25.3~),
-               xtl-dev (>= 0.6.23~),
+               xeus-dev (>= 1.0~),
+               xtl-dev (>= 0.7~),
                nlohmann-json3-dev (>= 3.6.1~),
                pybind11-dev (>= 2.2.4~),
-               pybind11-json-dev (>= 0.2.6~),
+               pybind11-json-dev (>= 0.2.8~),
                python3-dev,
 Standards-Version: 4.5.0
 Section: science

=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus-python/tags .*/archive/refs/tags/@ANY_VERSION@@ARCHIVE_EXT@

## xeus-python 0.14.3+~0.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,11 +45,16 @@
     "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
     "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
 )
+configure_file (
+    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json.in"
+    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json"
+)
 
 # Build options
 # =============
 
 # Compilation options
+
 OPTION(XPYT_DISABLE_ARCH_NATIVE "disable -march=native flag" OFF)
 OPTION(XPYT_DISABLE_TUNE_GENERIC "disable -mtune=generic flag" OFF)
 OPTION(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)
@@ -62,17 +67,36 @@
 OPTION(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
 OPTION(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)
 
+OPTION(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)
+
 # Test options
 OPTION(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
 OPTION(XPYT_DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)
 
+if(XPYT_EMSCRIPTEN_WASM_BUILD)
+    configure_file(wasm_patches/post.js ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
+
+    add_compile_definitions(XPYT_EMSCRIPTEN_WASM_BUILD)
+
+    set(XPYT_DISABLE_ARCH_NATIVE ON)
+    set(XPYT_BUILD_STATIC OFF)
+    set(XPYT_BUILD_SHARED OFF)
+    set(XPYT_BUILD_XPYTHON_EXECUTABLE OFF)
+    set(XPYT_BUILD_XPYTHON_EXTENSION OFF)
+    set(XPYT_USE_SHARED_XEUS OFF)
+    set(XPYT_USE_SHARED_XEUS_PYTHON OFF)
+    set(XPYT_BUILD_TESTS OFF)
+    set(XPYT_DOWNLOAD_GTEST OFF)
+endif()
+
 # Dependencies
 # ============
 
-set(xtl_REQUIRED_VERSION 0.6.23)
-set(xeus_REQUIRED_VERSION 0.25.0)
-set(pybind11_REQUIRED_VERSION 2.6.0)
+set(xtl_REQUIRED_VERSION 0.7.0)
+set(xeus_REQUIRED_VERSION 2.0.0)
+set(pybind11_REQUIRED_VERSION 2.6.1)
 set(pybind11_json_REQUIRED_VERSION 0.2.8)
+set(pyjs_REQUIRED_VERSION 0.7.0)
 
 if (NOT TARGET xtl)
     find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
@@ -86,6 +110,13 @@
 if (NOT TARGET pybind11_json)
     find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
 endif ()
+
+if(XPYT_EMSCRIPTEN_WASM_BUILD)
+    if (NOT TARGET pyjs)
+        find_package(pyjs ${pyjs_REQUIRED_VERSION} REQUIRED)
+    endif ()
+    configure_file(${pyjs_PRE_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/pre.js COPYONLY)
+endif()
 
 # Flags
 # =====
@@ -122,8 +153,6 @@
 set(XEUS_PYTHON_SRC
     src/xcomm.cpp
     src/xcomm.hpp
-    src/xcompiler.cpp
-    src/xcompiler.hpp
     src/xdebugger.cpp
     src/xdebugpy_client.hpp
     src/xdebugpy_client.cpp
@@ -131,9 +160,14 @@
     src/xdisplay.hpp
     src/xinput.cpp
     src/xinput.hpp
+    src/xinspect.cpp
+    src/xinspect.hpp
     src/xinternal_utils.cpp
     src/xinternal_utils.hpp
     src/xinterpreter.cpp
+    src/xinterpreter_raw.cpp
+    src/xkernel.cpp
+    src/xkernel.hpp
     src/xpaths.cpp
     src/xstream.cpp
     src/xstream.hpp
@@ -146,6 +180,7 @@
     include/xeus-python/xeus_python_config.hpp
     include/xeus-python/xpaths.hpp
     include/xeus-python/xinterpreter.hpp
+    include/xeus-python/xinterpreter_raw.hpp
     include/xeus-python/xtraceback.hpp
     include/xeus-python/xutils.hpp
 )
@@ -158,14 +193,48 @@
     src/xpython_extension.cpp
 )
 
+set(XEUS_PYTHON_WASM_SRC
+    src/xcomm.cpp
+    src/xcomm.hpp
+    src/xdisplay.cpp
+    src/xdisplay.hpp
+    src/xinput.cpp
+    src/xinput.hpp
+    src/xinspect.cpp
+    src/xinspect.hpp
+    src/xinternal_utils.cpp
+    src/xinternal_utils.hpp
+    src/xinterpreter.cpp
+    src/xinterpreter_wasm.cpp
+    src/xkernel.cpp
+    src/xkernel.hpp
+    src/xpaths.cpp
+    src/xstream.cpp
+    src/xstream.hpp
+    src/xtraceback.cpp
+    src/xutils.cpp
+)
+
+set(XEUS_PYTHON_WASM_HEADERS
+    include/xeus-python/xdebugger.hpp
+    include/xeus-python/xeus_python_config.hpp
+    include/xeus-python/xpaths.hpp
+    include/xeus-python/xinterpreter.hpp
+    include/xeus-python/xinterpreter_wasm.hpp
+    include/xeus-python/xtraceback.hpp
+    include/xeus-python/xutils.hpp
+)
+
+set(XPYTHON_WASM_SRC
+    src/main_wasm.cpp
+)
+
 # Targets and link - Macros
 # =========================
 
 include(CheckCXXCompilerFlag)
 
 string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)
-
-set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib; ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
 
 macro(xpyt_set_common_options target_name)
     if (MSVC)
@@ -195,21 +264,6 @@
             message(FATAL_ERROR "Unsupported compiler -- xeus-python requires C++14 support!")
         endif ()
     endif ()
-
-    if (APPLE)
-        set_target_properties(${target_name} PROPERTIES
-            MACOSX_RPATH ON
-        )
-    else ()
-        set_target_properties(${target_name} PROPERTIES
-            BUILD_WITH_INSTALL_RPATH 1
-            SKIP_BUILD_RPATH FALSE
-        )
-    endif ()
-
-    set_target_properties(${target_name} PROPERTIES
-        INSTALL_RPATH_USE_LINK_PATH TRUE
-    )
 endmacro()
 
 # Common macro kernels (xpython and xpython_extension)
@@ -218,7 +272,10 @@
         message(STATUS "Enabling PyPI warning for target: " ${target_name})
         target_compile_definitions(${target_name} PRIVATE XEUS_PYTHON_PYPI_WARNING)
     endif()
-
+endmacro()
+
+# Common macro for linking targets
+macro(xpyt_target_link_libraries target_name)
     if (XPYT_USE_SHARED_XEUS_PYTHON)
         target_link_libraries(${target_name} PRIVATE xeus-python)
 
@@ -231,21 +288,22 @@
 
     find_package(Threads) # TODO: add Threads as a dependence of xeus or xeus-static?
     target_link_libraries(${target_name} PRIVATE ${CMAKE_THREAD_LIBS_INIT})
+    set_target_properties(${target_name} PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
 endmacro()
 
 # Common macro for shared and static library xeus-python
-macro(xpyt_create_target target_name linkage output_name)
+macro(xpyt_create_target target_name src headers linkage output_name)
     string(TOUPPER "${linkage}" linkage_upper)
 
     if (NOT ${linkage_upper} MATCHES "^(SHARED|STATIC)$")
         message(FATAL_ERROR "Invalid library linkage: ${linkage}")
     endif ()
 
-    add_library(${target_name} ${linkage_upper} ${XEUS_PYTHON_SRC} ${XEUS_PYTHON_HEADERS})
+    add_library(${target_name} ${linkage_upper} ${src} ${headers})
     xpyt_set_common_options(${target_name})
 
     set_target_properties(${target_name} PROPERTIES
-                          PUBLIC_HEADER "${XEUS_PYTHON_HEADERS}"
+                          PUBLIC_HEADER "${headers}"
                           PREFIX ""
                           VERSION ${${PROJECT_NAME}_VERSION}
                           SOVERSION ${XPYT_VERSION_MAJOR}
@@ -277,8 +335,10 @@
 
     if (XEUS_PYTHONHOME_RELPATH)
         target_compile_definitions(${target_name} PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
-    endif()
-endmacro()
+    elseif (XEUS_PYTHONHOME_ABSPATH)
+        target_compile_definitions(${target_name} PRIVATE XEUS_PYTHONHOME_ABSPATH=${XEUS_PYTHONHOME_ABSPATH})
+    endif ()
+endmacro ()
 
 # xeus-python
 # ===========
@@ -287,73 +347,9 @@
 
 if (XPYT_BUILD_SHARED)
     # Build libraries
-    xpyt_create_target(xeus-python SHARED xeus-python)
+    xpyt_create_target(xeus-python "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" SHARED xeus-python)
     list(APPEND XEUS_PYTHON_TARGETS xeus-python)
 endif ()
 
 if (XPYT_BUILD_STATIC)
     # On Windows, a static library should use a different output name
-    # to avoid the conflict with the import library of a shared one.
-    if (CMAKE_HOST_WIN32)
-        xpyt_create_target(xeus-python-static STATIC xeus-python-static)
-    else ()
-        xpyt_create_target(xeus-python-static STATIC xeus-python)
-    endif ()
-    list(APPEND XEUS_PYTHON_TARGETS xeus-python-static)
-endif ()
-
-# xpython
-# =======
-
-if (XPYT_BUILD_XPYTHON_EXECUTABLE)
-    add_executable(xpython ${XPYTHON_SRC})
-    target_link_libraries(xpython PRIVATE pybind11::embed)
-
-    xpyt_set_common_options(xpython)
-    xpyt_set_kernel_options(xpython)
-endif()
-
-# xpython_extension
-# =================
-
-if (XPYT_BUILD_XPYTHON_EXTENSION)
-    pybind11_add_module(xpython_extension ${XPYTHON_EXTENSION_SRC})
-
-    xpyt_set_common_options(xpython_extension)
-    xpyt_set_kernel_options(xpython_extension)
-endif()
-
-# Tests
-# =====
-
-if(XPYT_DOWNLOAD_GTEST OR XPYT_GTEST_SRC_DIR)
-    set(XPYT_BUILD_TESTS ON)
-endif()
-
-if(XPYT_BUILD_TESTS)
-    add_subdirectory(test)
-endif()
-
-# Installation
-# ============
-
-include(CMakePackageConfigHelpers)
-
-set(XEUS_PYTHON_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for xeus-pythonConfig.cmake")
-
-# Install xeus-python and xeus-python-static
-if (XPYT_BUILD_SHARED)
-    install(TARGETS ${XEUS_PYTHON_TARGETS}
-            EXPORT ${PROJECT_NAME}-targets
-            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xeus-python)
-
-    # Makes the project importable from the build directory
-    export(EXPORT ${PROJECT_NAME}-targets
-           FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
-endif ()
-
-# Install xpython
-if (XPYT_BUILD_XPYTHON_EXECUTABLE)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -94,11 +94,6 @@
     set_target_properties(test_xeus_python PROPERTIES
         MACOSX_RPATH ON
     )
-else()
-    set_target_properties(test_xeus_python PROPERTIES
-        BUILD_WITH_INSTALL_RPATH 1
-        SKIP_BUILD_RPATH FALSE
-    )
 endif()
 
 set_target_properties(test_xeus_python PROPERTIES

=== debian/changelog ===
xeus-python (0.14.3+~0.5.0-3) unstable; urgency=medium

  * Standards-Version: 4.6.2
  * Rebuild against pybind11-dev >= 2.10.3

 -- Gordon Ball <gordon@chronitis.net>  Sat, 04 Feb 2023 20:51:31 +0000

xeus-python (0.14.3+~0.5.0-2) unstable; urgency=medium

  * Upload to unstable
  * Closes: #1016240

 -- Gordon Ball <gordon@chronitis.net>  Sat, 01 Oct 2022 21:04:47 +0000

xeus-python (0.14.3+~0.5.0-1) experimental; urgency=medium

  * Set CMAKE_BUILD_RPATH_USE_ORIGIN (reproducible builds, patch from Vagrant
    Cascadian). Closes: #1001860
  * Standards-Version: 4.6.0
  * New upstream version 0.14.3
    - Add component xeus-python-shell @ 0.5.0
  * New binary python3-xeus-python-shell

 -- Gordon Ball <gordon@chronitis.net>  Fri, 30 Sep 2022 21:44:05 +0000

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,18 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper-compat (= 13),
+               dh-python,
                cmake,
                pkg-config,
                libzmq3-dev,
-               xeus-dev (>= 1.0~),
+               xeus-dev (>= 2.0~),
                xtl-dev (>= 0.7~),
                nlohmann-json3-dev (>= 3.6.1~),
-               pybind11-dev (>= 2.2.4~),
+               pybind11-dev (>= 2.10.3~),
                pybind11-json-dev (>= 0.2.8~),
                python3-dev,
-Standards-Version: 4.5.0
+               python3-setuptools,
+Standards-Version: 4.6.2
 Section: science
 Homepage: https://github.com/jupyter-xeus/xeus-python
 Vcs-Git: https://salsa.debian.org/science-team/xeus-python.git
@@ -49,12 +51,20 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         python3-jedi,
-         python3-pygments,
-Recommends: python3-ipython
+         python3-xeus-python-shell,
 Description: Native jupyter kernel for python (binary)
  xeus-python uses the xeus library to provide a high-performance,
  native kernel for running python code in the jupyter notebook,
  or other frontends using the jupyter messaging protocol.
  .
  This package contains the xpython executable and jupyter kernel configuration.
+
+Package: python3-xeus-python-shell
+Architecture: all
+Depends: ${python3:Depends}, ${misc:Depends}
+Description: Native jupyter kernel for python (python library)
+ xeus-python uses the xeus library to provide a high-performance,
+ native kernel for running python code in the jupyter notebook,
+ or other frontends using the jupyter messaging protocol.
+ .
+ This package contains the python library used for the shell.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DPYTHON_EXECUTABLE=/usr/bin/python3 -DXPYT_DISABLE_ARCH_NATIVE=1 -DXPYT_DISABLE_TUNE_GENERIC=1 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
	dh_auto_configure -D xeus-python-shell --buildsystem pybuild

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -D xeus-python-shell --buildsystem pybuild

override_dh_auto_install:
	dh_auto_install
	dh_auto_install -D xeus-python-shell --buildsystem pybuild
